#include "Testing/CarePackageTests.h"
#include "map.h"
#include "set.h"
using namespace std;

Set<string> smallestCarePackageFor(const Vector<Set<string>>& preferences) {
    /* TODO: Replace this with your implementation. */
    (void) preferences;
    return {};
}

/***** Tests Below This Point *****/
ADD_TEST("Doesn't use a greedy strategy.") {
    /* The optimal solution here is to pick A and B, which collectively cover everyone.
     * But if you count up what the most popular option is and repeatedly pick that,
     * you'll grab options E, D, and C.
     */
    auto package = smallestCarePackageFor({
        { "A", "C" },
        { "A", "D" },
        { "A", "D" },
        { "A", "E" },
        { "A", "E" },
        { "A", "E" },
        { "A", "E" },
        { "B", "C" },
        { "B", "D" },
        { "B", "D" },
        { "B", "E" },
        { "B", "E" },
        { "B", "E" },
        { "B", "E" }
    });

    Set<string> expected = { "A", "B" };
    EXPECT(package == expected);
}

ADD_TEST("Passes example from exam. This should complete almost instanteously.") {
    auto package = smallestCarePackageFor({
        { "Pumpkin pie", "Revani", "Sufganiyot" },
        { "Castella", "Kheer", "Melktert" },
        { "Po'e", "Tangyuan", "Tres leches" },
        { "Apfelstrudel", "Tangyuan" },
        { "Alfajores", "Brigadeiro", "Revani" },
        { "Baklava", "Revani" },
        { "Melktert" },
        { "Brownies", "Cannolis", "Castella", "Po'e", "Revani" },
        { "Cendol", "Kashata", "Tangyuan" },
        { "Baklava", "Castella", "Kheer", "Revani" }
    });

    Set<string> expected = { "Melktert", "Revani", "Tangyuan" };
    EXPECT(package == expected);
}

ADD_TEST("Passes stress test. This should complete almost instanteously.") {
    auto package = smallestCarePackageFor({
        { "A", "F", "G" },
        { "B", "H", "I" },
        { "A", "J", "K" },
        { "C", "L", "M" },
        { "A", "N", "O" },
        { "B", "P", "Q" },
        { "A", "R", "S" },
        { "C", "T", "U" },
        { "A", "V", "W" },
        { "B", "X", "Y" },
        { "A", "Z", "!" },
    });

    Set<string> expected = { "A", "B", "C" };
    EXPECT(package == expected);
}
