#include "Testing/KCoreTests.h"
#include "map.h"
#include "set.h"
using namespace std;

Set<string> kCoreOf(const Map<string, Set<string>>& network, int k) {
    /* TODO: Replace this with your solution. */
    (void) network;
    (void) k;
    return {};
}

/***** Tests Below This Point *****/
ADD_TEST("Removes everyone linked in a line when k = 2.") {
    /* This list of friendships is given as follows:
     *
     * 0 - 9 - 1 - 8 - 2 - 7 - 3 - 6 - 4 - 5
     */
    EXPECT(kCoreOf({
        { "0", {"9"} },
        { "9", {"0", "1"} },
        { "1", {"9", "8"} },
        { "8", {"1", "2"} },
        { "2", {"8", "7"} },
        { "7", {"2", "3"} },
        { "3", {"7", "6"} },
        { "6", {"3", "4"} },
        { "4", {"5", "6"} },
        { "5", {"4"} },
    }, 2).isEmpty());
}

ADD_TEST("Core stable after multiple iterations") {
    /* This list of friendships is given as follows:
     *
     *
     * 9 -- 8 -- 2 --- 3 -- 4 -- 5
     *      |    | \ / |    |
     *      |    |  x  |    |
     *      |    | / \ |    |
     *      7 -- 1 --- 0 -- 6
     *
     */
    Map<string, Set<string>> network = {
        { "9", {"8"} },
        { "8", {"9", "2", "7"} },
        { "2", {"8", "1", "0", "3"} },
        { "3", {"2", "1", "0", "4"} },
        { "4", {"3", "5", "6"} },
        { "5", {"4"} },
        { "7", {"1", "8"} },
        { "1", {"7", "2", "3", "0"} },
        { "0", {"1", "2", "3", "6"} },
        { "6", {"0", "4"} },
    };

    Set<string> expected2 = { "0", "1", "2", "3", "4", "6", "7", "8" };
    EXPECT(kCoreOf(network, 2) == expected2);

    Set<string> expected3 = { "0", "1", "2", "3" };
    EXPECT(kCoreOf(network, 3) == expected3);

    Set<string> expected4 = {}; // Alas...
    EXPECT(kCoreOf(network, 4) == expected4);
}

ADD_TEST("Handles test case from exam") {
    /* This list of friendships is given as follows:
     *
     *
     *      8 --- 2 --- 3 -- 4
     *      | \   | \ / |    |
     *      |  \  |  x  |    |
     *      |   \ | / \ |    |
     *      7 --- 1 --- 0 -- 6
     *
     */
    Map<string, Set<string>> network = {
        { "8", {"1", "2", "7"} },
        { "2", {"8", "1", "0", "3"} },
        { "3", {"2", "1", "0", "4"} },
        { "4", {"3", "6"} },
        { "7", {"1", "8"} },
        { "1", {"7", "2", "3", "0"} },
        { "0", {"1", "2", "3", "6"} },
        { "6", {"0", "4"} },
    };

    Set<string> expected2 = { "0", "1", "2", "3", "4", "6", "7", "8" };
    EXPECT(kCoreOf(network, 2) == expected2);

    Set<string> expected3 = { "0", "1", "2", "3" };
    EXPECT(kCoreOf(network, 3) == expected3);

    Set<string> expected4 = {}; // Alas...
    EXPECT(kCoreOf(network, 4) == expected4);
}
